#include <Arduino.h>
#include "pb_encode.h"
#include "pb_decode.h"

#include "test.pb.h"

bool network_RoutingTable_callback(pb_istream_t *istream, pb_ostream_t *ostream, const pb_field_iter_t *field) {

  PB_UNUSED(istream);
  if (ostream != NULL && field->tag == network_RoutingTable_entries_tag) {

      for (uint32_t eid = 0; eid < 5; eid++) {

        network_RoutingEntry entry = network_RoutingEntry_init_zero;
        entry.address = eid;
        entry.metric = eid+2;

        if (!pb_encode_tag_for_field(ostream, field))
          return false;

        if (!pb_encode_submessage(ostream, network_RoutingEntry_fields, &entry))
          return false;
      }

  }

  return true;

}

void setup() {

  network_RoutingTable rt = network_RoutingTable_init_zero;

  pb_byte_t buffer[1024];
  pb_ostream_t output = pb_ostream_from_buffer(buffer, 1024);

  pb_encode_delimited(&output, network_RoutingTable_fields, &rt);

  size_t amountOfBytes = output.bytes_written;

  // send 'buffer', size 'amountOfBytes'
}

void loop() {


}
